import sys
from collections import Counter 

f = open(sys.argv[1])
c = f.readlines()
f.close()

cur_lev = 0
results = [] 

for line in c:
    line = line.strip()

    ## If empty line who even cares
    if line == "":
        continue

    ## If it's the header line, we're on next lev
    if line[0] == '#':
        cur_lev += 1
        results.append([])
        continue

    s = line.split()

    if len(s) == 4:
        s = [s[0], f'{s[1]} {s[2]}', s[3]]
    
    results[cur_lev - 1].append(s)

## Winners

print('Winners')

winners = Counter()

week = 1
for lev in results:
    winner = lev[0][1]
    print(f'Week {week}: {winner}')
    winners[winner] += 1
    week += 1

## Most Wins

print('\nMost Wins')

for winner in winners.most_common():
    print(f'{winner[0]:24}{winner[1]}')
